;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; syslog-port.scm - Scheme port interface to syslog.
;;;

(declare
  (module syslog-port)
  (import data-structures ports syslog)
  (export current-syslog-port open-syslog))

(define (open-syslog identity priority #!optional (options opt/pid) (facility facility/user))
  (define buffer
    (make-string 0))
  (define (writer s)
    (cond
      ((substring-index "\n" s) =>
       (lambda (i)
         (openlog identity options facility)
         (syslog priority (string-append buffer (substring s 0 i)))
         (writer (substring s (add1 i)))
         (set! buffer (make-string 0))))
      (else
       (set! buffer (string-append buffer s)))))
  (make-output-port writer void))

(define current-syslog-port
  (make-parameter (open-syslog (program-name) prio/info)))
